LTC = {};

---------
function LTC:OnLoad()
---------
	SLASH_LOST_TREASURE_CHECK1 = "/ltc";
	SlashCmdList["LOST_TREASURE_CHECK"] = function(msg) LTC:HandleSlashCommand(msg) end

	LTCFrame:RegisterEvent("PLAYER_LOGIN")
	LTCFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
	LTCFrame:RegisterEvent("ADDON_LOADED")
end

---------
function LTC:OnEvent(self, event, ...)
---------
	local arg1, arg2, arg3, arg4 = ...
	if event == "ADDON_LOADED" and arg1 == "Lost Treasure Check" then
		LTCFrame:UnregisterEvent("ADDON_LOADED");
	elseif event == "PLAYER_LOGIN" then
		LTCFrame:UnregisterEvent("PLAYER_LOGIN");
		LTC:LoadData();
		LTC:Announce();		
	elseif event == "PLAYER_ENTERING_WORLD" then
		LTCFrame:UnregisterEvent("PLAYER_ENTERING_WORLD");
	end
end

---------
function LTC:LoadData()

	LTC_flags = {
		-- The Jade Forest
		[806] = {
			[31402] = { ["name"] = "Ancient Jinyu Staff", 						["itemID"] = 86196 },
			[31399] = { ["name"] = "Ancient Pandaren Mining Pick", 				["itemID"] = 85777 },
			[31400] = { ["name"] = "Ancient Pandaren Tea Pot", 					["itemID"] = 85780 },
			[31403] = { ["name"] = "Hammer of Ten Thunders", 					["itemID"] = 86198 },
			[31307] = { ["name"] = "Jade Infused Blade", 						["itemID"] = 86199 },
			[31401] = { ["name"] = "Lucky Pandaren Coin",						["itemID"] = 85781 },
			[31865] = { ["name"] = "Offering of Rememberance",					["itemID"] = nil   },
			[31404] = { ["name"] = "Pandaren Ritual Stone",						["itemID"] = 86216 },
			[31396] = { ["name"] = "Ship's Locker",								["itemID"] = nil   },
			[31866] = { ["name"] = "Stash of Gems",								["itemID"] = nil   },
			[31397] = { ["name"] = "Wodin's Mantid Shanker", 					["itemID"] = 85776 }
		},

		-- Valley of the Four Winds
		[807] = {
			[31284] = { ["name"] = "Ancient Pandaren Fishing Charm", 			["itemID"] = 85973 },
			[31292] = { ["name"] = "Ancient Pandaren Woodcutter",				["itemID"] = 86079 },
			[31869] = { ["name"] = "Boat-Building Instructions",				["itemID"] = nil   },
			[31406] = { ["name"] = "Cache of Pilfered Goods",					["itemID"] = nil   },
			[31407] = { ["name"] = "Staff of the Hidden Master",				["itemID"] = 86218 },
			[31405] = { ["name"] = "Virmen Treasure Cache",						["itemID"] = nil   }
		},

		-- Krasarang Wilds
		[857] = {
			[31410] = { ["name"] = "Equipment Locker",							["itemID"] = nil   },
			[31409] = { ["name"] = "Pandaren Fishing Spear",					["itemID"] = 86124 },
			[31411] = { ["name"] = "Recipe: Banana Infused Rum",				["itemID"] = 87266 },
			[31408] = { ["name"] = "Saurok Stone Tablet",						["itemID"] = 86220 },
			[31863] = { ["name"] = "Stack of Papers",							["itemID"] = 87798 }
		},

		-- The Veiled Stair
		[873] = {
			[31867] = { ["name"] = "Forgotten Lockbox",							["itemID"] = nil   },
			[31428] = { ["name"] = "Hammer of Folly",							["itemID"] = 86473 }
		},

		-- Kun-Lai Summit
		[809] = {
			[31420] = { ["name"] = "Ancient Mogu Tablet",						["itemID"] = 86471 },
			[31414] = { ["name"] = "Hozen Treasure Cache",						["itemID"] = nil   },
			[31413] = { ["name"] = "Hozen Warrior Spear",						["itemID"] = 86394 },
			[31304] = { ["name"] = "Kafa Press",								["itemID"] = 86125 },
			[31418] = { ["name"] = "Lost Adventurer's Belongings",				["itemID"] = nil   },
			[31868] = { ["name"] = "Mo-Mo's Treasure Chest",					["itemID"] = nil   },
			[31419] = { ["name"] = "Rikktik's Tick Remover",					["itemID"] = 86430 },
			[31412] = { ["name"] = "Sprite's Cloth Chest",						["itemID"] = nil   },
			[31416] = { ["name"] = "Statue of Xuen",							["itemID"] = 86422 },
			[31415] = { ["name"] = "Stolen Sprite Treasure",					["itemID"] = nil   },
			[31421] = { ["name"] = "Sturdy Yaungol Spear",						["itemID"] = 88723 },
			[31417] = { ["name"] = "Tablet of Ren Yun",							["itemID"] = 86393 },
			[31422] = { ["name"] = "Terracotta Head", 							["itemID"] = 86427 }
		},

		-- Townlong Steppes
		[810] = {
			[31427] = { ["name"] = "Abandoned Crate of Goods",					["itemID"] = nil   },
			[31426] = { ["name"] = "Amber Encased Moth",						["itemID"] = 86472 },
			[31423] = { ["name"] = "Fragment of Dread",							["itemID"] = 86516 },
			[31424] = { ["name"] = "Hardened Sap of Kri'vess",					["itemID"] = 86517 },
			[31425] = { ["name"] = "Yaungol Fire Carrier",						["itemID"] = 86518 },
		},

		-- Dread Wastes
		[858] = {
			[31438] = { ["name"] = "Blade of the Poisoned Mind",				["itemID"] = 86527 },
			[31433] = { ["name"] = "Blade of the Prime",						["itemID"] = 86522 },
			[31436] = { ["name"] = "Bloodsoaked Chitin Fragment",				["itemID"] = 86525 },
			[31864] = { ["name"] = "Chest of Supplies",							["itemID"] = nil   },
			[31435] = { ["name"] = "Dissector's Staff of Mutation",				["itemID"] = 86524 },
			[31431] = { ["name"] = "Lucid Amulet of the Agile Mind",			["itemID"] = 86521 },
			[31430] = { ["name"] = "Malik's Stalwart Spear",					["itemID"] = 86520 },
			[31432] = { ["name"] = "Manipulator's Talisman",					["itemID"] = 86529 },
			[31437] = { ["name"] = "Swarmkeeper's Medallion",					["itemID"] = 86526 },
			[31434] = { ["name"] = "Swarming Cleaver of Ka'roz",				["itemID"] = 86523 },
			[31429] = { ["name"] = "Wind-Reaver's Dagger of Quick Strikes",		["itemID"] = 86519 }
		},
		
		-- Timeless Isle
		[951] = {
			[33170] = { ["name"] = "Moss Covered Chest 01", 	["x"] = 36.7, ["y"] = 34.1,		["note"] = "Three-Breeze Terrace",												["itemID"] = nil   },
			[33171] = { ["name"] = "Moss Covered Chest 02", 	["x"] = 25.5, ["y"] = 27.2,		["note"] = "Misty Strand",														["itemID"] = nil   },
			[33172] = { ["name"] = "Moss Covered Chest 03", 	["x"] = 27.4, ["y"] = 39.1,		["note"] = "South of Misty Strand",												["itemID"] = nil   },
			[33173] = { ["name"] = "Moss Covered Chest 04", 	["x"] = 30.7, ["y"] = 36.5,		["note"] = "On a stump, southwest of Three-Breeze Terrace",						["itemID"] = nil   },
			[33174] = { ["name"] = "Moss Covered Chest 05", 	["x"] = 22.4, ["y"] = 35.4,		["note"] = "Underwater North of Horde base",									["itemID"] = nil   },
			[33175] = { ["name"] = "Moss Covered Chest 06", 	["x"] = 22.1, ["y"] = 49.3,		["note"] = "Next to some turtles south of Horde base",							["itemID"] = nil   },
			[33176] = { ["name"] = "Moss Covered Chest 07", 	["x"] = 24.8, ["y"] = 53.0,		["note"] = "Next to some turtles southeast of Horde base" ,						["itemID"] = nil   },
			[33177] = { ["name"] = "Moss Covered Chest 08", 	["x"] = 25.7, ["y"] = 45.8,		["note"] = "Southeast of Horde base",											["itemID"] = nil   },
			[33178] = { ["name"] = "Moss Covered Chest 09", 	["x"] = 22.3, ["y"] = 68.1,		["note"] = "Next to some turtles north of Alliance base",						["itemID"] = nil   },
			[33179] = { ["name"] = "Moss Covered Chest 10",		["x"] = 26.8, ["y"] = 68.7,		["note"] = "At the base of the mountain northeast of Alliance base",			["itemID"] = nil   },
			[33180] = { ["name"] = "Moss Covered Chest 11",		["x"] = 31.0, ["y"] = 76.3,		["note"] = "In a bush between Alliance base and Old Pi'jiu",					["itemID"] = nil   },
			[33181] = { ["name"] = "Moss Covered Chest 12",		["x"] = 35.3, ["y"] = 76.4,		["note"] = "Inside western building of Old Pi'jiu",								["itemID"] = nil   },
			[33182] = { ["name"] = "Moss Covered Chest 13",		["x"] = 38.7, ["y"] = 71.6,		["note"] = "Inside northern building of Old Pi'jiu",							["itemID"] = nil   },
			[33183] = { ["name"] = "Moss Covered Chest 14",		["x"] = 39.8, ["y"] = 79.5,		["note"] = "Inside eastern building of Old Pi'jiu",								["itemID"] = nil   },
			[33184] = { ["name"] = "Moss Covered Chest 15",		["x"] = 34.8, ["y"] = 84.2,		["note"] = "Underneath the dock at Old Pi'jiu's Jetty",							["itemID"] = nil   },
			[33185] = { ["name"] = "Moss Covered Chest 16",		["x"] = 43.6, ["y"] = 84.1,		["note"] = "In a bush southeast of Old Pi'jiu",									["itemID"] = nil   },
			[33186] = { ["name"] = "Moss Covered Chest 17", 	["x"] = 47.0, ["y"] = 53.7, 	["note"] = "Bottom of the central lake",										["itemID"] = nil   },
			[33187] = { ["name"] = "Moss Covered Chest 18",		["x"] = 46.7, ["y"] = 46.7,		["note"] = "Next to a tree North of the central lake",							["itemID"] = nil   },
			[33188] = { ["name"] = "Moss Covered Chest 19",		["x"] = 51.2, ["y"] = 45.7,		["note"] = "Under the broken bridge in the Slump Scraps",						["itemID"] = nil   },
			[33189] = { ["name"] = "Moss Covered Chest 20", 	["x"] = 55.5, ["y"] = 44.3,		["note"] = "Next to Tsavo'ka's Cave",											["itemID"] = nil   },
			[33190] = { ["name"] = "Moss Covered Chest 21",		["x"] = 58.0, ["y"] = 50.7,		["note"] = "At the base of a tree next to the Mysterious Cave",					["itemID"] = nil   },
			[33191] = { ["name"] = "Moss Covered Chest 22",		["x"] = 65.7, ["y"] = 47.8,		["note"] = "At the base of a tree Behind the graveyard",						["itemID"] = nil   },
			[33192] = { ["name"] = "Moss Covered Chest 23", 	["x"] = 63.8, ["y"] = 59.2,		["note"] = "At the base of a tree south of the graveyard",						["itemID"] = nil   },
			[33193] = { ["name"] = "Moss Covered Chest 24",		["x"] = 64.9, ["y"] = 75.6,		["note"] = "In the Croaking Hollow",											["itemID"] = nil   },
			[33194] = { ["name"] = "Moss Covered Chest 25",		["x"] = 60.2, ["y"] = 66.0,		["note"] = "At the base of a tree southwest of the graveyard",					["itemID"] = nil   },
			[33195] = { ["name"] = "Moss Covered Chest 26",		["x"] = 49.7, ["y"] = 65.7,		["note"] = "At the base of a tree south of the central lake",					["itemID"] = nil   },
			[33196] = { ["name"] = "Moss Covered Chest 27",		["x"] = 53.1, ["y"] = 70.8,		["note"] = "At the base of a tree southeast of the central lake",				["itemID"] = nil   },
			[33197] = { ["name"] = "Moss Covered Chest 28",		["x"] = 52.7, ["y"] = 62.7,		["note"] = "At the base of a tree southeast of the central lake",				["itemID"] = nil   },
			[33227] = { ["name"] = "Moss Covered Chest 29",		["x"] = 61.7, ["y"] = 88.5,		["note"] = "Underwater in the shipwreck",										["itemID"] = nil   },
			[33198] = { ["name"] = "Moss Covered Chest 30",		["x"] = 44.2, ["y"] = 65.3,		["note"] = "On a stump southeast of the Celestial Court",						["itemID"] = nil   },
			[33199] = { ["name"] = "Moss Covered Chest 31",		["x"] = 26.0, ["y"] = 61.4,		["note"] = "On a stump north of the Alliance base",								["itemID"] = nil   },
			[33200] = { ["name"] = "Moss Covered Chest 32",		["x"] = 24.6, ["y"] = 38.5,		["note"] = "On a stump north of the Horde base",								["itemID"] = nil   },
			[33202] = { ["name"] = "Moss Covered Chest 33",		["x"] = 29.7, ["y"] = 31.8,		["note"] = "On the ramp at the southeastern corner of the Misty Strand",		["itemID"] = nil   },
			[33201] = { ["name"] = "Moss Covered Chest 34",		["x"] = 59.9, ["y"] = 31.3,		["note"] = "Next to a tree at the Ordon Sanctuary Graveyard",					["itemID"] = nil   },
			
			[33203] = { ["name"] = "Skull-Covered Chest", 		["x"] = 46.7, ["y"] = 32.3,		["note"] = "Inside the Cavern of Lost Spirits",									["itemID"] = nil   },
			[33204] = { ["name"] = "Sturdy Chest",				["x"] = 28.2, ["y"] = 35.2, 	["note"] = "Take the Albatross taxi to the pillar North of the Horde base",		["itemID"] = nil	},
			[33205] = { ["name"] = "Sturdy Chest",				["x"] = 26.8, ["y"] = 64.9,		["note"] = "Take the Albatross taxi to the pillar North of the Alliance base", 	["itemID"] = nil   },
			[33206] = { ["name"] = "Sturdy Chest",				["x"] = 64.6, ["y"] = 70.4,		["note"] = "In the Croaking Hollow",											["itemID"] = nil   },
			[33207] = { ["name"] = "Sturdy Chest",				["x"] = 59.2, ["y"] = 49.5,		["note"] = "Inside the Mysterious Den", 										["itemID"] = nil   },
			[33208] = { ["name"] = "Smouldering Chest 01",		["x"] = 69.5, ["y"] = 32.9,		["note"] = "In the Shrine of the Black Flame",									["itemID"] = nil   },
			[33209] = { ["name"] = "Smouldering Chest 02",		["x"] = 54.0, ["y"] = 78.2,		["note"] = "In the Firewalker Ruins",											["itemID"] = nil   },
			[33210] = { ["name"] = "Blazing Chest",				["x"] = 47.6, ["y"] = 27.6,		["note"] = "Western court of the Ordon Sanctuary",								["itemID"] = nil   },
			
			[32956] = { ["name"] = "Blackguard's Jetsam (|cff00ccffWeekly|r)",			["x"] = 22.5, ["y"] = 58.9,		["note"] = "Inside underwater cave",								["itemID"] = nil   },
			[32957] = { ["name"] = "Sunken Treasure (|cff00ccffWeekly|r)",				["x"] = 40.4, ["y"] = 92.3,		["note"] = "In the belly of the sunken ship. Requires a key looted from the nearby hozen",								["itemID"] = nil   },
			[32970] = { ["name"] = "Gleaming Treasure Satchel (|cff00ccffWeekly|r)",	["x"] = 70.7, ["y"] = 80.9,		["note"] = "Hanging from the crossbeam of the ship",				["itemID"] = nil   }
		
		}
	}
	
	LTC_items = {};

	LTC_location_order = {806,807,857,873,809,810,858,951};

	LTC_total = LTC:CountFlags();
end

---------
function LTC:Announce()
---------
	DEFAULT_CHAT_FRAME:AddMessage(YELLOW_FONT_COLOR_CODE.."LostTreasureCheck |rloaded "..GREEN_FONT_COLOR_CODE..LTC_total.."|r items.");
end

---------
function LTC:HandleSlashCommand(cmd)
---------
	if string.lower(cmd) == "all" then
		LTC:CheckFlags(nil, true);
	elseif string.lower(cmd) == "zone" then
		LTC:CheckFlags(LTC:GetLocationID(), false)
	elseif string.lower(cmd) == "zone all" then
		LTC:CheckFlags(LTC:GetLocationID(), true)
	elseif string.lower(cmd) == "wp" or string.lower(cmd) == "waypoint" then
		if(TomTom ~= nil) then
			LTC:AddWayPoints(LTC:GetLocationID())
		else
			DEFAULT_CHAT_FRAME:AddMessage(YELLOW_FONT_COLOR_CODE.."Lost Treasure Check:|r"..RED_FONT_COLOR_CODE.." ERROR|r".." - Waypoints option requires"..GREEN_FONT_COLOR_CODE.."TomTom|r addon.|r");
		end
	else
		LTC:CheckFlags(nil, false);
	end
end

---------
function LTC:GetLocationID()
---------
	SetMapToCurrentZone();
	return GetCurrentMapAreaID();
end

---------
function LTC:CountFlags()
---------
	local count = 0;
	for loc,ids in pairs(LTC_flags)
	do
		for _ in pairs(LTC_flags[loc])
		do
			count = count + 1;
		end
	end
	return count;
end

---------
function LTC:CheckFlags(locationID, showCompleted)
---------
	LTC:PrintHeader();

	local completed = 0;

	if not locationID then
		-- No location specified, show all locations
		if LTC_location_order then
			-- Retrieve locations
			for index, loc in pairs(LTC_location_order)
			do
				completed = completed + LTC:CheckLocationFlags(loc, showCompleted);
				LTC:PrintLocationFooter();
			end
		LTC:PrintFooter(completed);
		end
	else
		-- Show only the specified location
		completed = LTC:CheckLocationFlags(locationID, showCompleted);
		LTC:PrintSeparatorLine();
	end
end

---------
function LTC:CheckLocationFlags(locationID, showCompleted)
---------
	local completed = 0;
	local total = 0;
	local isCompleted = {};
	local orderedFlags = {};

	if locationID then
		-- Retrieve quest flag IDs by location
		if(LTC_flags[locationID]) then
			-- Check if each flag is completed and increment counts
			for questID,info in pairs(LTC_flags[locationID])
			do
				total = total + 1;
				if IsQuestFlaggedCompleted(questID) == 1 then
					isCompleted[questID] = true;
					completed = completed + 1;
				else
					isCompleted[questID] = false;
				end;
				-- Insert flag IDs into a list for sorting later
				table.insert(orderedFlags, questID);
			end

			-- Sort flag IDs to maintain order
			table.sort(orderedFlags);

			LTC:PrintLocationHeader(locationID, total, completed);

			-- Only print this location's header if we have flags to display
			if showCompleted or (total - completed) > 0 then
				LTC:PrintLocationFlags(locationID, orderedFlags, isCompleted, showCompleted);
			end
		else
			LTC:PrintLocationHeader(locationID, 0, 0);
		end
	end

	return completed;
end

---------
function LTC:AddWayPoints(locationID)
---------
	local added = 0;
	local total = 0;
	
	if(LTC_flags[locationID]) then
		-- Check if each flag is completed and increment counts
		for questID,info in pairs(LTC_flags[locationID])
		do
			if (questID ~= nil) then
				total = total + 1;
				if IsQuestFlaggedCompleted(questID) ~= 1 then
					added = added + 1;
					
					local x,y = LTC:GetFlagCoords(locationID, questID)
					
					local desc = LTC:GetFlagNote(locationID, questID)
					
					TomTom:AddWaypoint(x, y, desc, false, true, true, true)
				end
			end
		end
	end
	
	if (added > 0) then
		TomTom:SetClosestWaypoint()
		DEFAULT_CHAT_FRAME:AddMessage(YELLOW_FONT_COLOR_CODE.."Lost Treasure Check: |r"..GREEN_FONT_COLOR_CODE..added.."|r waypoint(s) added.|r");
	else
		DEFAULT_CHAT_FRAME:AddMessage(YELLOW_FONT_COLOR_CODE.."Lost Treasure Check: No waypoints added.|r");
	end
end

---------
function LTC:CountCompleted(locationID)
---------

end

---------
function LTC:PrintHeader()
---------
	--LTC:PrintSeparatorLine();
	DEFAULT_CHAT_FRAME:AddMessage(YELLOW_FONT_COLOR_CODE.."Lost Treasure Check: |r");
	LTC:PrintSeparatorLine();
end

---------
function LTC:PrintFooter(completed)
---------
	--LTC:PrintSeparatorLine();
	DEFAULT_CHAT_FRAME:AddMessage(YELLOW_FONT_COLOR_CODE.."Total Treasures Found: |r"..completed.."/"..LTC_total);
	LTC:PrintSeparatorLine();
end

---------
function LTC:PrintSeparatorLine()
---------
	DEFAULT_CHAT_FRAME:AddMessage("---------------------------|r");
	end

---------
function LTC:PrintLocationHeader(locationID, total, completed)
---------
	DEFAULT_CHAT_FRAME:AddMessage(YELLOW_FONT_COLOR_CODE..GetMapNameByID(locationID).."|r ("..(total - completed).." of "..total..RED_FONT_COLOR_CODE.." missing|r): ");
end

---------
function LTC:PrintLocationFlags(locationID, flags, isCompleted, showCompleted)
---------
	for index,questID in pairs(flags)
	do
		local link;
		local c = isCompleted[questID];
		local itemID = LTC:GetItemID(locationID, questID);
		local x, y = LTC:GetFlagCoords(locationID, questID);
		local note = LTC:GetFlagNote(locationID, questID);

		if itemID ~= nil then
			link = LTC:GetItemLink(itemID);			
		end	

		if link == nil then
			link = LTC:GetFlagName(locationID, questID);
		end

		LTC:PrintFlagInfo(link, x, y, note, c, showCompleted)
	end
end

---------
function LTC:PrintLocationFooter()
---------
	DEFAULT_CHAT_FRAME:AddMessage("\n");
end

---------
function LTC:PrintFlagInfo(link, x, y, note, isCompleted, showCompleted)
---------
	if not isCompleted then	
		if (x ~= nil and y ~= nil and note ~= nil) then
			DEFAULT_CHAT_FRAME:AddMessage(" - "..link..": "..RED_FONT_COLOR_CODE.."Missing! |r - ("..x.." , "..y..") - "..note);
		elseif (note ~= nil) then
			DEFAULT_CHAT_FRAME:AddMessage(" - "..link..": "..RED_FONT_COLOR_CODE.."Missing! |r - "..note);
		else
			DEFAULT_CHAT_FRAME:AddMessage(" - "..link..": "..RED_FONT_COLOR_CODE.."Missing! |r");
		end
	elseif showCompleted then		
			DEFAULT_CHAT_FRAME:AddMessage(" - "..link..": "..GREEN_FONT_COLOR_CODE.."Found |r");
	end
end
---------
function LTC:GetItemID(locationID, questID)
---------
	return LTC_flags[locationID][questID]["itemID"];
end

---------
function LTC:GetFlagName(locationID, questID)
---------
	if (LTC_flags[locationID][questID]["name"] ~= nil) then
		return LTC_flags[locationID][questID]["name"];
	else
		return "";
	end
end

---------
function LTC:GetFlagCoords(locationID, questID)
---------
	local x = nil
	local y = nil
	
	if (LTC_flags[locationID][questID]["x"] ~= nil) then
		x = LTC_flags[locationID][questID]["x"];
	end
	if (LTC_flags[locationID][questID]["y"] ~= nil) then
		y = LTC_flags[locationID][questID]["y"];
	end
	return x,y	
end

---------
function LTC:GetFlagNote(locationID, questID)
---------	
	if (LTC_flags[locationID][questID]["note"] ~= nil) then
		return LTC_flags[locationID][questID]["note"];
	else
		return "";
	end
end

---------
function LTC:GetItemLink(itemID)
---------
	if (itemID ~= nil) then
		local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount,itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(itemID);
		return itemLink;	
	else
		return nil;
	end
end
